// Data: 29/03/2021  2 Semestre de 2020.
// Prof. Dr. Jean M. Simo - DAINF/UTFPR Curitiba-Central.

// UNIVERSIDADE TECNOLGICA FEDERAL DO PARAN - Campus de Curitiba Central 
// Dep. Acadmico de Informtica (DAINF). Disciplina: Tcnicas de Programao  CSE20.
// Prova sobre linguagem C++ / Diagrama de Classes (UML) / Orientao a Objetos  Prova 1 Parcial

// Nome do(a) Discente: __________________________________________________ Turma: S71
// Curso: _____ .__________ Horrio de Comeo: ____________ Horrio de Fim: _____________

// Leia toda a prova, pois os enunciados esto completados uns nos outros.
// Utilize os bons princpios de projeto e programao orientada a objetos.
// Em tempo, questes de mesmo peso, idem para os tpicos dentro delas (quando houver).

// A interpretao faz parte do contedo da prova! Inclua comentrios (se for o caso) para deixar explicitas suas decises.  Pgina 1/1.


#include <iostream>
#include <vector>
using namespace std;

#define LIMIAR1 5000
#define LIMIAR2 1000
#define CICLOS  100

// (Questo - 1)
class Ente
{
    protected:
        long int id;

    public:

        Ente(const long int i = -1):
        id (i)
        {
        }

        virtual ~Ente()
        {
        }

        const long int getId() const { return id; }
};

// (Questo - 2)

class Virus : public Ente
{
    private:
        bool mutacao;
        static int contador_mutg;
        static long int cont_id;

    public:
        Virus(const long int i = -1, const bool m = false):
        Ente(i),
        mutacao(m)
        {
        }

        ~Virus()
        {
        }

        Virus* replicarse()
        {
            Virus* pvirus = NULL;
            pvirus = new Virus (cont_id++, false);

            if (cont_id > LIMIAR1)
            {
                if (contador_mutg >= LIMIAR2)
                {
                    pvirus->setMutacao (true);
                    contador_mutg = 0;
                    return pvirus;
                }
                else
                {
                    contador_mutg++;
                }
            }

            return pvirus;
        }

        void setMutacao(const bool m)
        {
            mutacao = m;
        }

        const float getMutacao() const
        {
            return mutacao;
        }
};

int Virus::contador_mutg    = 0;
long int Virus::cont_id     = 1;


// (Questo - 3)

class ConjEntes
{
    private:

       vector<Ente*> individuos;

    public:
        ConjEntes() : individuos()
        {
        }

        ~ConjEntes()
        {
            vector<Ente*>::iterator It;

            Ente* paux = NULL;

            It = individuos.begin();

            while (It != individuos.end())
            {
                paux = *It;

                if (paux != NULL)
                {
                    delete paux;
                }

                paux = NULL;

                It++;
            }

            individuos.clear();

            // Em vez de iterador, poderia ser feito com operador []
        }

        void incluir(Ente* pa)
        {
            if (pa != NULL)
            {
                individuos.push_back(pa);
                //cout << "Incluido!" << endl;
            }
            else
            {
                cerr << "Erro - apontamento nulo" << endl;
            }
        }

        Ente* excluir_ultimo()
        {
            Ente* paux = NULL;

            paux = individuos[getQuantidade()-1];

            //cout << "A quantidade : " << getQuantidade() << endl;
            //cout << "O Id do ltimo ente : " << (int)paux->getId() << endl;
            //system("pause");

            individuos.pop_back();

            return paux;
        }

        const long int getQuantidade() const
        {
            return individuos.size();
        }

        Ente* operator[](long int i) const
        {
            if ( ( i >= 0 ) && (i < getQuantidade() ) )
            {
                return individuos[i];
                //return individuos.at(i);
            }
            else
            {
                return NULL;
            }
        }

};

// (Questo - 4)

class Pessoa : public Ente
{
    private:
        ConjEntes carga_viral;

    public:
        Pessoa(const long int i = -1) :
        Ente(i),
        carga_viral()
        {

        }

        ~Pessoa()
        {
        }

        virtual void contaminarse(Virus* pV)
        {
            if (pV)
            {
               carga_viral.incluir(pV);
            }
        }

        void curarse()
        {
            if (contaminado())
            {
                Virus* pv = NULL;

                pv = (Virus*)carga_viral.excluir_ultimo();

                if (pv)
                {
                    if (pv->getMutacao())
                    {
                        pv->setMutacao(false);
                        carga_viral.incluir(pv);
                    }
                    else
                    {
                        delete pv;
                        pv = NULL;
                    }
                }
            }
        }

        const bool contaminado() const
        {
            return carga_viral.getQuantidade()? true : false;
        }
};

// (Questo - 5)

class Sociedade
{
    private:
        ConjEntes   conj_pessoas;
        Virus       virus_original;
        long int    num_pessoas;

    public:

    Sociedade(const long int np = 0) :
        conj_pessoas(),
        virus_original(0),
        num_pessoas(np)
    {
        Pessoa* pP = NULL;

        long int quant_infec = -1;

        long int dois = -1;

        quant_infec = (long int) ( (np / 100) * (np / 100) );

        dois = (long int) ( ( 2 * np ) / 100 );

        for (long int i = 0; i < num_pessoas; i++)
        {
            pP = new Pessoa(i);
            conj_pessoas.incluir(static_cast<Ente*>(pP));

            if (i < quant_infec)
            {
                for (long int i = 0; i < dois; i++)
                {
                    Virus* pV = NULL;
                    pV = virus_original.replicarse();
                    pP->contaminarse(pV);
                }
            }
        }

        cout << "TUDO CRIADO!" << endl;
    }

    ~Sociedade()
    {
    }

    void executar()
    {
        int nao_contaminados = 0;
        int contaminados = 0;

        Pessoa* pP = NULL;
        //int tam = (int) conj_pessoas.getQuantidadade();

        for ( int j = 0; j < CICLOS; j++)
        {

            for ( long int i = 0; i < num_pessoas; i++)
            {
                //cout << "PASSEI AQUI!" << (int)i << endl;
                pP = (Pessoa*)conj_pessoas[i];

                if (pP != NULL)
                {
                    pP->curarse();
                }
                else
                {
                    cout << "Ponteiro Nulo!" << endl;
                }

            }
        }



        for ( long int k = 0; k < num_pessoas; k++)
        {
            pP = (Pessoa*)conj_pessoas[k];
            if (pP->contaminado())
            {
                contaminados++;
            }
            else
            {
                nao_contaminados++;
            }
        }

        cout << endl;
        cout << "Nesta sociedade o nmero de pessoas circulando foi de: " << num_pessoas << endl;
        cout << "Assim, tem-se neste momento o que segue: " << endl;
        cout << "- Nao contaminados: " << nao_contaminados << endl;
        cout << "- Contaminados: " << contaminados << endl;
        cout << endl;
    }
};

int main()
{
    Sociedade sociedade1 (1000);
    sociedade1.executar();

    Sociedade sociedade2 (5000);
    sociedade2.executar();

    Sociedade sociedade3 (10000);
    sociedade3.executar();

    return 0;
}

